var fs = require('fs');
var npm = require('npm');
var path = require('path');

var PATH_PACKAGE_JSON = path.join(process.cwd(), 'package.json');

var PREPUBLISH_ARG = process.argv[2] == '--prepublish';

var npmScripts;

prepublish();

function killProcess(force) {
	if (PREPUBLISH_ARG || force) {
		process.kill(process.pid);
	}
}

function preventDefaultPublish(cb) {
	process.once('beforeExit', cb);

	process.exit();
}

function prepublish() {
	var exec = require('child_process').exec;

	var packageJson = require(PATH_PACKAGE_JSON);

	npmScripts = packageJson.scripts;

	delete packageJson.scripts;

	writePackageJson(packageJson);

	var FRONTEND_THEMES_WEB = 'frontend-themes-web';

	var PATH_FRONTEND_THEMES_WEB = path.join(__dirname, '../../../');

	if (path.basename(PATH_FRONTEND_THEMES_WEB) === FRONTEND_THEMES_WEB || true) {
		var exec = require('child_process').exec;

		var antBuildThemes = exec(
			'ant build-themes',
			{
				cwd: PATH_FRONTEND_THEMES_WEB
			},
			function(error, stdout, stderr) {
				if (error && false) {
					console.log('Aborting npm publish due to build failure');

					killProcess(true);
				}
				else {
					npmPublish();
				}
			}
		);

		var write = function(data) {
			process.stdout.write(data);
		};

		antBuildThemes.stderr.on('data', write);
		antBuildThemes.stdout.on('data', write);
	}
	else {
		killProcess();
	}
}

function npmPublish() {
	npm.load(
		{
			loaded: false
		},
		function() {
			npm.commands.publish(
				function(err, another) {
					if (err) {
						throw err;
					}

					//revertPackageJson();

					killProcess();
				}
			);
		}
	);
}

function revertPackageJson() {
	var packageJson = require(PATH_PACKAGE_JSON);

	packageJson.scritps = npmScripts;

	writePackageJson(packageJson);
}

function writePackageJson(json) {
	fs.writeFileSync(PATH_PACKAGE_JSON, JSON.stringify(json, null, '\t'));
}
